Package org.apache.lucene.facet.taxonomy

## Class IntTaxonomyFacets

- java.lang.Object
- - org.apache.lucene.facet.Facets
  - - org.apache.lucene.facet.taxonomy.TaxonomyFacets
    - - org.apache.lucene.facet.taxonomy.IntTaxonomyFacets

- Direct Known Subclasses:
    `FastTaxonomyFacetCounts`, `TaxonomyFacetCounts`, `TaxonomyFacetIntAssociations`

      @Deprecated
      public abstract class IntTaxonomyFacets
      extends TaxonomyFacets

  Deprecated.
  Visibility of this class will be reduced to pkg-private in a future version. This class is meant to host common code as an internal implementation detail to `FastTaxonomyFacetCounts` and `TaxonomyFacetIntAssociations`,and is not intended as an extension point for user-created `Facets` implementations. If your code is relying on this, please migrate necessary functionality down into your own class.
  Base class for all taxonomy-based facets that aggregate to a per-ords int[].

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected AssociationAggregationFunction` | `aggregationFunction` | Deprecated. Aggregation function used for combining values.
    `protected com.carrotsearch.hppc.IntIntHashMap` | `sparseValues` | Deprecated. Sparse ordinal values.
    `protected int[]` | `values` | Deprecated. Dense ordinal values.

    - ### Fields inherited from class org.apache.lucene.facet.taxonomy.TaxonomyFacets

      `config, indexFieldName, taxoReader`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `IntTaxonomyFacets​(String indexFieldName, TaxonomyReader taxoReader, FacetsConfig config, FacetsCollector fc)` | Deprecated. Constructor that defaults the aggregation function to `AssociationAggregationFunction.SUM`.
    `protected` | `IntTaxonomyFacets​(String indexFieldName, TaxonomyReader taxoReader, FacetsConfig config, AssociationAggregationFunction aggregationFunction, FacetsCollector fc)` | Deprecated. Constructor that uses the provided aggregation function.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `FacetResult` | `getAllChildren​(String dim, String... path)` | Deprecated. Returns all child labels with non-zero counts under the specified path.
    `Number` | `getSpecificValue​(String dim, String... path)` | Deprecated. Return the count or value for a specific path.
    `FacetResult` | `getTopChildren​(int topN, String dim, String... path)` | Deprecated. Returns the topN child labels under the specified path.
    `List<FacetResult>` | `getTopDims​(int topNDims, int topNChildren)` | Deprecated. Returns labels for topN dimensions and their topNChildren sorted by the number of hits/aggregated values that dimension matched.
    `protected int` | `getValue​(int ordinal)` | Deprecated. Get the count for this ordinal.
    `protected void` | `increment​(int ordinal)` | Deprecated. Increment the count for this ordinal by 1.
    `protected void` | `increment​(int ordinal, int amount)` | Deprecated. Increment the count for this ordinal by `amount`..
    `protected void` | `rollup()` | Deprecated. Rolls up any single-valued hierarchical dimensions.
    `protected boolean` | `useHashTable​(FacetsCollector fc, TaxonomyReader taxoReader)` | Deprecated. Return true if a sparse hash table should be used for counting, instead of a dense int[].

    - ### Methods inherited from class org.apache.lucene.facet.taxonomy.TaxonomyFacets

      `childrenLoaded, getAllDims, siblingsLoaded, verifyDim`

    - ### Methods inherited from class org.apache.lucene.facet.Facets

      `validateTopN`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### aggregationFunction

          protected final AssociationAggregationFunction aggregationFunction

      Deprecated.
      Aggregation function used for combining values.

    - #### values

          protected final int[] values

      Deprecated.
      Dense ordinal values.

      We are making this and `sparseValues` protected for some expert usage. e.g. It can be checked which is being used before a loop instead of calling `increment(int)` for each iteration.

    - #### sparseValues

          protected final com.carrotsearch.hppc.IntIntHashMap sparseValues

      Deprecated.
      Sparse ordinal values.
      See Also:
        `for why protected.`

  - ### Constructor Detail

    - #### IntTaxonomyFacets

          protected IntTaxonomyFacets​(String indexFieldName,
                                      TaxonomyReader taxoReader,
                                      FacetsConfig config,
                                      FacetsCollector fc)
                               throws IOException

      Deprecated.
      Constructor that defaults the aggregation function to `AssociationAggregationFunction.SUM`.
      Throws:
        `IOException`

    - #### IntTaxonomyFacets

          protected IntTaxonomyFacets​(String indexFieldName,
                                      TaxonomyReader taxoReader,
                                      FacetsConfig config,
                                      AssociationAggregationFunction aggregationFunction,
                                      FacetsCollector fc)
                               throws IOException

      Deprecated.
      Constructor that uses the provided aggregation function.
      Throws:
        `IOException`

  - ### Method Detail

    - #### useHashTable

          protected boolean useHashTable​(FacetsCollector fc,
                                         TaxonomyReader taxoReader)

      Deprecated.
      Return true if a sparse hash table should be used for counting, instead of a dense int[].

    - #### increment

          protected void increment​(int ordinal)

      Deprecated.
      Increment the count for this ordinal by 1.

    - #### increment

          protected void increment​(int ordinal,
                                   int amount)

      Deprecated.
      Increment the count for this ordinal by `amount`..

    - #### getValue

          protected int getValue​(int ordinal)

      Deprecated.
      Get the count for this ordinal.

    - #### rollup

          protected void rollup()
                         throws IOException

      Deprecated.
      Rolls up any single-valued hierarchical dimensions.
      Throws:
        `IOException`

    - #### getSpecificValue

          public Number getSpecificValue​(String dim,
                                         String... path)
                                  throws IOException

      Deprecated.
      Description copied from class: `Facets`
      Return the count or value for a specific path. Returns -1 if this path doesn't exist, else the count.
      Specified by:
        `getSpecificValue` in class `Facets`
      Throws:
        `IOException`

    - #### getAllChildren

          public FacetResult getAllChildren​(String dim,
                                            String... path)
                                     throws IOException

      Deprecated.
      Description copied from class: `Facets`
      Returns all child labels with non-zero counts under the specified path. Users should make no assumptions about ordering of the children. Returns null if the specified path doesn't exist or if this dimension was never seen.
      Specified by:
        `getAllChildren` in class `Facets`
      Throws:
        `IOException`

    - #### getTopChildren

          public FacetResult getTopChildren​(int topN,
                                            String dim,
                                            String... path)
                                     throws IOException

      Deprecated.
      Description copied from class: `Facets`
      Returns the topN child labels under the specified path. Returns null if the specified path doesn't exist or if this dimension was never seen.
      Specified by:
        `getTopChildren` in class `Facets`
      Throws:
        `IOException`

    - #### getTopDims

          public List<FacetResult> getTopDims​(int topNDims,
                                              int topNChildren)
                                       throws IOException

      Deprecated.
      Description copied from class: `Facets`
      Returns labels for topN dimensions and their topNChildren sorted by the number of hits/aggregated values that dimension matched. Results should be the same as calling getAllDims and then only using the first topNDims. Note that dims should be configured as requiring dim counts if using this functionality to ensure accurate counts are available (see: `FacetsConfig.setRequireDimCount(String, boolean)`).

      Sub-classes may want to override this implementation with a more efficient one if they are able.

      Overrides:
        `getTopDims` in class `Facets`
      Throws:
        `IOException`